﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy3 Experiment Builder (v2022.2.1),
    on July 08, 2022, at 18:10
If you publish work using this script the most relevant publication is:

    Peirce J, Gray JR, Simpson S, MacAskill M, Höchenberger R, Sogo H, Kastman E, Lindeløv JK. (2019) 
        PsychoPy2: Experiments in behavior made easy Behav Res 51: 195. 
        https://doi.org/10.3758/s13428-018-01193-y

"""

# --- Import packages ---
from psychopy import locale_setup
from psychopy import prefs
from psychopy import sound, gui, visual, core, data, event, logging, clock, colors, layout
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)

import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle, choice as randchoice
import os  # handy system and path functions
import sys  # to get file system encoding

import psychopy.iohub as io
from psychopy.hardware import keyboard

# Run 'Before Experiment' code from code_2
import random
import pandas as pd
import numpy as np
import time
from math import log10
import audioop
import pyaudio
# Run 'Before Experiment' code from code_3
import random



# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__))
os.chdir(_thisDir)
# Store info about the experiment session
psychopyVersion = '2022.2.1'
expName = 'Sentence Completion'  # from the Builder filename that created this script
expInfo = {
    'participant': '',
    'session': '001',
}
# --- Show participant info dialog --
dlg = gui.DlgFromDict(dictionary=expInfo, sortKeys=False, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName
expInfo['psychopyVersion'] = psychopyVersion

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath='C:\\Users\\tanay\\OneDrive\\Desktop\\UPENN\\LCNS\\Sentence Completion\\Sentence Completion_lastrun.py',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp
frameTolerance = 0.001  # how close to onset before 'same' frame

# Start Code - component code to be run after the window creation
# Make folder to store recordings from mic
micRecFolder = filename + '_mic_recorded'
if not os.path.isdir(micRecFolder):
    os.mkdir(micRecFolder)

# --- Setup the Window ---
win = visual.Window(
    size=[1280, 720], fullscr=False, screen=0, 
    winType='pyglet', allowStencil=False,
    monitor='testMonitor', color='black', colorSpace='rgb',
    blendMode='avg', useFBO=True, 
    units='height')
win.mouseVisible = True
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess
# --- Setup input devices ---
ioConfig = {}

# Setup iohub keyboard
ioConfig['Keyboard'] = dict(use_keymap='psychopy')

ioSession = '1'
if 'session' in expInfo:
    ioSession = str(expInfo['session'])
ioServer = io.launchHubServer(window=win, **ioConfig)
eyetracker = None

# create a default keyboard (e.g. to check for escape)
defaultKeyboard = keyboard.Keyboard(backend='iohub')

# --- Initialize components for Routine "ready" ---
ready_text = visual.TextStim(win=win, name='ready_text',
    text='~\n',
    font='Arial',
    pos=(-0.8,-0.5), height=0.08, wrapWidth=1.0, ori=0.0, 
    color='grey', colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=0.0);
skip_instr_3 = keyboard.Keyboard()

# --- Initialize components for Routine "instr_1" ---
text_instr = visual.TextStim(win=win, name='text_instr',
    text='',
    font='Arial',
    pos=(0, 0), height=0.06, wrapWidth=1.0, ori=0.0, 
    color='grey', colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=0.0);
skip_instr_2 = keyboard.Keyboard()

# --- Initialize components for Routine "instr_2" ---
text_instr_3 = visual.TextStim(win=win, name='text_instr_3',
    text='',
    font='Arial',
    pos=(0, 0), height=0.06, wrapWidth=1.0, ori=0.0, 
    color='grey', colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=0.0);
skip_instr_5 = keyboard.Keyboard()

# --- Initialize components for Routine "instr_3" ---
text_instr_4 = visual.TextStim(win=win, name='text_instr_4',
    text='',
    font='Arial',
    pos=(0, 0), height=0.06, wrapWidth=1.0, ori=0.0, 
    color='grey', colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=0.0);
skip_instr_6 = keyboard.Keyboard()

# --- Initialize components for Routine "display_test" ---
trial_begin = visual.TextStim(win=win, name='trial_begin',
    text='',
    font='Arial',
    pos=(0, 0), height=0.12, wrapWidth=1.0, ori=0.0, 
    color='grey', colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=0.0);
# Run 'Begin Experiment' code from code_2
trial_clock = core.Clock()

init_db = []

p = pyaudio.PyAudio()
WIDTH = 2
RATE = int(p.get_default_input_device_info()['defaultSampleRate'])
DEVICE = p.get_default_input_device_info()['index']
rms = 1
tm = time.time()

def callback(in_data, frame_count, time_info, status):
    global rms
    rms = audioop.rms(in_data, WIDTH) / 32767
    return in_data, pyaudio.paContinue
    
stream = p.open(format=p.get_format_from_width(WIDTH),
                input_device_index=DEVICE,
                channels=1,
                rate=RATE,
                input=True,
                output=False,
                stream_callback=callback)



# --- Initialize components for Routine "disp_seg_1" ---
seg_1 = visual.TextStim(win=win, name='seg_1',
    text='',
    font='Arial',
    pos=(0, 0), height=0.06, wrapWidth=1.0, ori=0.0, 
    color='grey', colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=-1.0);

# --- Initialize components for Routine "disp_seg_2" ---
seg_2 = visual.TextStim(win=win, name='seg_2',
    text='',
    font='Arial',
    pos=(0, 0), height=0.06, wrapWidth=1.0, ori=0.0, 
    color='grey', colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=0.0);

# --- Initialize components for Routine "disp_seg_3" ---
seg_3 = visual.TextStim(win=win, name='seg_3',
    text='',
    font='Arial',
    pos=(0, 0), height=0.06, wrapWidth=1.0, ori=0.0, 
    color='grey', colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=0.0);

# --- Initialize components for Routine "disp_seg_4" ---
seg_4 = visual.TextStim(win=win, name='seg_4',
    text='',
    font='Arial',
    pos=(0, 0), height=0.06, wrapWidth=1.0, ori=0.0, 
    color='grey', colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=-1.0);
mic = sound.microphone.Microphone(
    device=None, channels=None, 
    sampleRateHz=48000, maxRecordingSize=24000.0
)

# --- Initialize components for Routine "fixation" ---
Crosshair = visual.TextStim(win=win, name='Crosshair',
    text='+',
    font='Arial',
    pos=(0, 0), height=0.12, wrapWidth=1.0, ori=0.0, 
    color='grey', colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=0.0);

# --- Initialize components for Routine "block_rest" ---
end_block = visual.TextStim(win=win, name='end_block',
    text='END OF GROUP TRIALS.\nPRESS "A" TO CONTINUE.',
    font='Arial',
    pos=(0, 0), height=0.06, wrapWidth=1.0, ori=0.0, 
    color='grey', colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=0.0);
skip_instr_7 = keyboard.Keyboard()

# --- Initialize components for Routine "finish" ---
finish_text = visual.TextStim(win=win, name='finish_text',
    text="You're finished with this section! Thanks for participating! Click to exit.",
    font='Arial',
    pos=(0, 0), height=0.04, wrapWidth=1.0, ori=0.0, 
    color='grey', colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=0.0);
mouse_instr = event.Mouse(win=win)
x, y = [None, None]
mouse_instr.mouseClock = core.Clock()
skip_instr = keyboard.Keyboard()

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.Clock()  # to track time remaining of each (possibly non-slip) routine 

# --- Prepare to start Routine "ready" ---
continueRoutine = True
# update component parameters for each repeat
skip_instr_3.keys = []
skip_instr_3.rt = []
_skip_instr_3_allKeys = []
# keep track of which components have finished
readyComponents = [ready_text, skip_instr_3]
for thisComponent in readyComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "ready" ---
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *ready_text* updates
    if ready_text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        ready_text.frameNStart = frameN  # exact frame index
        ready_text.tStart = t  # local t and not account for scr refresh
        ready_text.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(ready_text, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'ready_text.started')
        ready_text.setAutoDraw(True)
    
    # *skip_instr_3* updates
    waitOnFlip = False
    if skip_instr_3.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        skip_instr_3.frameNStart = frameN  # exact frame index
        skip_instr_3.tStart = t  # local t and not account for scr refresh
        skip_instr_3.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(skip_instr_3, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'skip_instr_3.started')
        skip_instr_3.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(skip_instr_3.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(skip_instr_3.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if skip_instr_3.status == STARTED and not waitOnFlip:
        theseKeys = skip_instr_3.getKeys(keyList=['apostrophe','quoteleft'], waitRelease=False)
        _skip_instr_3_allKeys.extend(theseKeys)
        if len(_skip_instr_3_allKeys):
            skip_instr_3.keys = _skip_instr_3_allKeys[-1].name  # just the last key pressed
            skip_instr_3.rt = _skip_instr_3_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in readyComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "ready" ---
for thisComponent in readyComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "ready" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# --- Prepare to start Routine "instr_1" ---
continueRoutine = True
# update component parameters for each repeat
text_instr.setText('You will see a sentence with the last word missing. Your task is to complete each sentence with the first word that comes to mind that could end the sentence.')
skip_instr_2.keys = []
skip_instr_2.rt = []
_skip_instr_2_allKeys = []
# keep track of which components have finished
instr_1Components = [text_instr, skip_instr_2]
for thisComponent in instr_1Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "instr_1" ---
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *text_instr* updates
    if text_instr.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        text_instr.frameNStart = frameN  # exact frame index
        text_instr.tStart = t  # local t and not account for scr refresh
        text_instr.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(text_instr, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'text_instr.started')
        text_instr.setAutoDraw(True)
    
    # *skip_instr_2* updates
    waitOnFlip = False
    if skip_instr_2.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        skip_instr_2.frameNStart = frameN  # exact frame index
        skip_instr_2.tStart = t  # local t and not account for scr refresh
        skip_instr_2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(skip_instr_2, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'skip_instr_2.started')
        skip_instr_2.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(skip_instr_2.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(skip_instr_2.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if skip_instr_2.status == STARTED and not waitOnFlip:
        theseKeys = skip_instr_2.getKeys(keyList=['a'], waitRelease=False)
        _skip_instr_2_allKeys.extend(theseKeys)
        if len(_skip_instr_2_allKeys):
            skip_instr_2.keys = _skip_instr_2_allKeys[-1].name  # just the last key pressed
            skip_instr_2.rt = _skip_instr_2_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in instr_1Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "instr_1" ---
for thisComponent in instr_1Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "instr_1" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# --- Prepare to start Routine "instr_2" ---
continueRoutine = True
# update component parameters for each repeat
text_instr_3.setText('For example, if the sentence is “To keep the dogs out of the yard he put up a ___.”, you could say ‘fence’ or ‘wall’.')
skip_instr_5.keys = []
skip_instr_5.rt = []
_skip_instr_5_allKeys = []
# keep track of which components have finished
instr_2Components = [text_instr_3, skip_instr_5]
for thisComponent in instr_2Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "instr_2" ---
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *text_instr_3* updates
    if text_instr_3.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        text_instr_3.frameNStart = frameN  # exact frame index
        text_instr_3.tStart = t  # local t and not account for scr refresh
        text_instr_3.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(text_instr_3, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'text_instr_3.started')
        text_instr_3.setAutoDraw(True)
    
    # *skip_instr_5* updates
    waitOnFlip = False
    if skip_instr_5.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        skip_instr_5.frameNStart = frameN  # exact frame index
        skip_instr_5.tStart = t  # local t and not account for scr refresh
        skip_instr_5.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(skip_instr_5, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'skip_instr_5.started')
        skip_instr_5.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(skip_instr_5.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(skip_instr_5.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if skip_instr_5.status == STARTED and not waitOnFlip:
        theseKeys = skip_instr_5.getKeys(keyList=['a'], waitRelease=False)
        _skip_instr_5_allKeys.extend(theseKeys)
        if len(_skip_instr_5_allKeys):
            skip_instr_5.keys = _skip_instr_5_allKeys[-1].name  # just the last key pressed
            skip_instr_5.rt = _skip_instr_5_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in instr_2Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "instr_2" ---
for thisComponent in instr_2Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "instr_2" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# --- Prepare to start Routine "instr_3" ---
continueRoutine = True
# update component parameters for each repeat
text_instr_4.setText('Please respond as quickly and as accurately as possible.')
skip_instr_6.keys = []
skip_instr_6.rt = []
_skip_instr_6_allKeys = []
# keep track of which components have finished
instr_3Components = [text_instr_4, skip_instr_6]
for thisComponent in instr_3Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "instr_3" ---
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *text_instr_4* updates
    if text_instr_4.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        text_instr_4.frameNStart = frameN  # exact frame index
        text_instr_4.tStart = t  # local t and not account for scr refresh
        text_instr_4.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(text_instr_4, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'text_instr_4.started')
        text_instr_4.setAutoDraw(True)
    
    # *skip_instr_6* updates
    waitOnFlip = False
    if skip_instr_6.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        skip_instr_6.frameNStart = frameN  # exact frame index
        skip_instr_6.tStart = t  # local t and not account for scr refresh
        skip_instr_6.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(skip_instr_6, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'skip_instr_6.started')
        skip_instr_6.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(skip_instr_6.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(skip_instr_6.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if skip_instr_6.status == STARTED and not waitOnFlip:
        theseKeys = skip_instr_6.getKeys(keyList=['a'], waitRelease=False)
        _skip_instr_6_allKeys.extend(theseKeys)
        if len(_skip_instr_6_allKeys):
            skip_instr_6.keys = _skip_instr_6_allKeys[-1].name  # just the last key pressed
            skip_instr_6.rt = _skip_instr_6_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in instr_3Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "instr_3" ---
for thisComponent in instr_3Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "instr_3" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
block = data.TrialHandler(nReps=1.0, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('media/SentConditions.xlsx'),
    seed=None, name='block')
thisExp.addLoop(block)  # add the loop to the experiment
thisBlock = block.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisBlock.rgb)
if thisBlock != None:
    for paramName in thisBlock:
        exec('{} = thisBlock[paramName]'.format(paramName))

for thisBlock in block:
    currentLoop = block
    # abbreviate parameter names if possible (e.g. rgb = thisBlock.rgb)
    if thisBlock != None:
        for paramName in thisBlock:
            exec('{} = thisBlock[paramName]'.format(paramName))
    
    # --- Prepare to start Routine "display_test" ---
    continueRoutine = True
    # update component parameters for each repeat
    trial_begin.setText(Group)
    # Run 'Begin Routine' code from code_2
    sheet = pd.read_excel(StimPath)
    
    stream.start_stream()
    db = abs(20 * log10(rms))
    
    def generate_trial_order(sheet):
        pop_indexes = list(range(sheet.shape[0]))
        random.shuffle(pop_indexes)
    
        i = 0
        while i < len(pop_indexes)-3:
            if (sheet.at[pop_indexes[i], "Condition"]) == (sheet.at[pop_indexes[i+1], "Condition"]) and (sheet.at[pop_indexes[i+1], "Condition"]) == (sheet.at[pop_indexes[i+2], "Condition"]) and (sheet.at[pop_indexes[i+2], "Condition"]) == (sheet.at[pop_indexes[i+3], "Condition"]):
                random.shuffle(pop_indexes)
                i=0
            i+=1
        return pop_indexes
    
    trial_order = generate_trial_order(sheet)
    
    def comb_segments(trial_index, seg_i):
        segmen = ""
        for i in range(1, seg_i+1):
            segmen += sheet.at[trial_order[trial_index], ("Seg" + str(i))] + " "
        return segmen
    
    trial_index = 0
    
    # keep track of which components have finished
    display_testComponents = [trial_begin]
    for thisComponent in display_testComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "display_test" ---
    while continueRoutine and routineTimer.getTime() < 3.0:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *trial_begin* updates
        if trial_begin.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            trial_begin.frameNStart = frameN  # exact frame index
            trial_begin.tStart = t  # local t and not account for scr refresh
            trial_begin.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(trial_begin, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'trial_begin.started')
            trial_begin.setAutoDraw(True)
        if trial_begin.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > trial_begin.tStartRefresh + 3.0-frameTolerance:
                # keep track of stop time/frame for later
                trial_begin.tStop = t  # not accounting for scr refresh
                trial_begin.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'trial_begin.stopped')
                trial_begin.setAutoDraw(False)
        # Run 'Each Frame' code from code_2
        get_curr = time.time()
        if get_curr - tm >= 0.3:
            db = abs(20 * log10(rms))
            init_db.append(db)
            tm = get_curr
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in display_testComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "display_test" ---
    for thisComponent in display_testComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # Run 'End Routine' code from code_2
    avg_db = np.mean(init_db)
    threshold = 0.85*avg_db
    # using non-slip timing so subtract the expected duration of this Routine
    routineTimer.addTime(-3.000000)
    
    # set up handler to look after randomisation of conditions etc
    trials = data.TrialHandler(nReps=len(trial_order), method='random', 
        extraInfo=expInfo, originPath=-1,
        trialList=[None],
        seed=None, name='trials')
    thisExp.addLoop(trials)  # add the loop to the experiment
    thisTrial = trials.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
    if thisTrial != None:
        for paramName in thisTrial:
            exec('{} = thisTrial[paramName]'.format(paramName))
    
    for thisTrial in trials:
        currentLoop = trials
        # abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
        if thisTrial != None:
            for paramName in thisTrial:
                exec('{} = thisTrial[paramName]'.format(paramName))
        
        # --- Prepare to start Routine "disp_seg_1" ---
        continueRoutine = True
        # update component parameters for each repeat
        # Run 'Begin Routine' code from code_4
        for col in sheet.columns:
            thisExp.addData(col, sheet.at[trial_order[trial_index], col])
        # keep track of which components have finished
        disp_seg_1Components = [seg_1]
        for thisComponent in disp_seg_1Components:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        frameN = -1
        
        # --- Run Routine "disp_seg_1" ---
        while continueRoutine:
            # get current time
            t = routineTimer.getTime()
            tThisFlip = win.getFutureFlipTime(clock=routineTimer)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *seg_1* updates
            if seg_1.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                seg_1.frameNStart = frameN  # exact frame index
                seg_1.tStart = t  # local t and not account for scr refresh
                seg_1.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(seg_1, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'seg_1.started')
                seg_1.setAutoDraw(True)
            if seg_1.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > seg_1.tStartRefresh + SegTime-frameTolerance:
                    # keep track of stop time/frame for later
                    seg_1.tStop = t  # not accounting for scr refresh
                    seg_1.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'seg_1.stopped')
                    seg_1.setAutoDraw(False)
            if seg_1.status == STARTED:  # only update if drawing
                seg_1.setText(comb_segments(trial_index, 1), log=False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in disp_seg_1Components:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # --- Ending Routine "disp_seg_1" ---
        for thisComponent in disp_seg_1Components:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # the Routine "disp_seg_1" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # --- Prepare to start Routine "disp_seg_2" ---
        continueRoutine = True
        # update component parameters for each repeat
        # keep track of which components have finished
        disp_seg_2Components = [seg_2]
        for thisComponent in disp_seg_2Components:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        frameN = -1
        
        # --- Run Routine "disp_seg_2" ---
        while continueRoutine:
            # get current time
            t = routineTimer.getTime()
            tThisFlip = win.getFutureFlipTime(clock=routineTimer)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *seg_2* updates
            if seg_2.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                seg_2.frameNStart = frameN  # exact frame index
                seg_2.tStart = t  # local t and not account for scr refresh
                seg_2.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(seg_2, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'seg_2.started')
                seg_2.setAutoDraw(True)
            if seg_2.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > seg_2.tStartRefresh + SegTime-frameTolerance:
                    # keep track of stop time/frame for later
                    seg_2.tStop = t  # not accounting for scr refresh
                    seg_2.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'seg_2.stopped')
                    seg_2.setAutoDraw(False)
            if seg_2.status == STARTED:  # only update if drawing
                seg_2.setText(comb_segments(trial_index, 2), log=False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in disp_seg_2Components:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # --- Ending Routine "disp_seg_2" ---
        for thisComponent in disp_seg_2Components:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # the Routine "disp_seg_2" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # --- Prepare to start Routine "disp_seg_3" ---
        continueRoutine = True
        # update component parameters for each repeat
        # keep track of which components have finished
        disp_seg_3Components = [seg_3]
        for thisComponent in disp_seg_3Components:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        frameN = -1
        
        # --- Run Routine "disp_seg_3" ---
        while continueRoutine:
            # get current time
            t = routineTimer.getTime()
            tThisFlip = win.getFutureFlipTime(clock=routineTimer)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *seg_3* updates
            if seg_3.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                seg_3.frameNStart = frameN  # exact frame index
                seg_3.tStart = t  # local t and not account for scr refresh
                seg_3.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(seg_3, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'seg_3.started')
                seg_3.setAutoDraw(True)
            if seg_3.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > seg_3.tStartRefresh + SegTime-frameTolerance:
                    # keep track of stop time/frame for later
                    seg_3.tStop = t  # not accounting for scr refresh
                    seg_3.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'seg_3.stopped')
                    seg_3.setAutoDraw(False)
            if seg_3.status == STARTED:  # only update if drawing
                seg_3.setText(comb_segments(trial_index, 3), log=False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in disp_seg_3Components:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # --- Ending Routine "disp_seg_3" ---
        for thisComponent in disp_seg_3Components:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # the Routine "disp_seg_3" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # --- Prepare to start Routine "disp_seg_4" ---
        continueRoutine = True
        # update component parameters for each repeat
        # Run 'Begin Routine' code from code_3
        trial_tStart = None
        trial_tStop = None
        trial_tStartRefresh = None
        trial_tStopRefresh = None
        trial_status = NOT_STARTED
        
        init_time = time.time()
        start_microphone = False
        trial_clock.reset()
        
        # keep track of which components have finished
        disp_seg_4Components = [seg_4, mic]
        for thisComponent in disp_seg_4Components:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        frameN = -1
        
        # --- Run Routine "disp_seg_4" ---
        while continueRoutine:
            # get current time
            t = routineTimer.getTime()
            tThisFlip = win.getFutureFlipTime(clock=routineTimer)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            # Run 'Each Frame' code from code_3
            if time.time() - init_time > SentTime:
                start_microphone = True
            if abs(20 * log10(rms)) <= threshold:
                start_microphone = True
            
            # *seg_4* updates
            if seg_4.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                seg_4.frameNStart = frameN  # exact frame index
                seg_4.tStart = t  # local t and not account for scr refresh
                seg_4.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(seg_4, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'seg_4.started')
                seg_4.setAutoDraw(True)
            if seg_4.status == STARTED:
                if bool(start_microphone):
                    # keep track of stop time/frame for later
                    seg_4.tStop = t  # not accounting for scr refresh
                    seg_4.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'seg_4.stopped')
                    seg_4.setAutoDraw(False)
            if seg_4.status == STARTED:  # only update if drawing
                seg_4.setText(comb_segments(trial_index, 4), log=False)
            
            # mic updates
            if mic.status == NOT_STARTED and start_microphone:
                # keep track of start time/frame for later
                mic.frameNStart = frameN  # exact frame index
                mic.tStart = t  # local t and not account for scr refresh
                mic.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(mic, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.addData('mic.started', t)
                # start recording with mic
                mic.start()
                mic.status = STARTED
            if mic.status == STARTED:
                # update recorded clip for mic
                mic.poll()
            if mic.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > mic.tStartRefresh + 3-frameTolerance:
                    # keep track of stop time/frame for later
                    mic.tStop = t  # not accounting for scr refresh
                    mic.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.addData('mic.stopped', t)
                    # stop recording with mic
                    mic.stop()
                    mic.status = FINISHED
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in disp_seg_4Components:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # --- Ending Routine "disp_seg_4" ---
        for thisComponent in disp_seg_4Components:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # Run 'End Routine' code from code_3
        trial_index +=1
        
        # tell mic to keep hold of current recording in mic.clips and transcript (if applicable) in mic.scripts
        # this will also update mic.lastClip and mic.lastScript
        mic.stop()
        tag = data.utils.getDateStr()
        micClip = mic.bank(
            tag=tag, transcribe='None',
            config=None
        )
        trials.addData('mic.clip', os.path.join(micRecFolder, 'recording_mic_%s.wav' % tag))
        # the Routine "disp_seg_4" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # --- Prepare to start Routine "fixation" ---
        continueRoutine = True
        # update component parameters for each repeat
        # keep track of which components have finished
        fixationComponents = [Crosshair]
        for thisComponent in fixationComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        frameN = -1
        
        # --- Run Routine "fixation" ---
        while continueRoutine:
            # get current time
            t = routineTimer.getTime()
            tThisFlip = win.getFutureFlipTime(clock=routineTimer)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *Crosshair* updates
            if Crosshair.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                Crosshair.frameNStart = frameN  # exact frame index
                Crosshair.tStart = t  # local t and not account for scr refresh
                Crosshair.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(Crosshair, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'Crosshair.started')
                Crosshair.setAutoDraw(True)
            if Crosshair.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > Crosshair.tStartRefresh + FixTime-frameTolerance:
                    # keep track of stop time/frame for later
                    Crosshair.tStop = t  # not accounting for scr refresh
                    Crosshair.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'Crosshair.stopped')
                    Crosshair.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in fixationComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # --- Ending Routine "fixation" ---
        for thisComponent in fixationComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # the Routine "fixation" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        thisExp.nextEntry()
        
    # completed len(trial_order) repeats of 'trials'
    
    
    # --- Prepare to start Routine "block_rest" ---
    continueRoutine = True
    # update component parameters for each repeat
    skip_instr_7.keys = []
    skip_instr_7.rt = []
    _skip_instr_7_allKeys = []
    # keep track of which components have finished
    block_restComponents = [end_block, skip_instr_7]
    for thisComponent in block_restComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "block_rest" ---
    while continueRoutine:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *end_block* updates
        if end_block.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            end_block.frameNStart = frameN  # exact frame index
            end_block.tStart = t  # local t and not account for scr refresh
            end_block.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(end_block, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'end_block.started')
            end_block.setAutoDraw(True)
        
        # *skip_instr_7* updates
        waitOnFlip = False
        if skip_instr_7.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            skip_instr_7.frameNStart = frameN  # exact frame index
            skip_instr_7.tStart = t  # local t and not account for scr refresh
            skip_instr_7.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(skip_instr_7, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'skip_instr_7.started')
            skip_instr_7.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(skip_instr_7.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(skip_instr_7.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if skip_instr_7.status == STARTED and not waitOnFlip:
            theseKeys = skip_instr_7.getKeys(keyList=['a'], waitRelease=False)
            _skip_instr_7_allKeys.extend(theseKeys)
            if len(_skip_instr_7_allKeys):
                skip_instr_7.keys = _skip_instr_7_allKeys[-1].name  # just the last key pressed
                skip_instr_7.rt = _skip_instr_7_allKeys[-1].rt
                # a response ends the routine
                continueRoutine = False
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in block_restComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "block_rest" ---
    for thisComponent in block_restComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # the Routine "block_rest" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
# completed 1.0 repeats of 'block'


# --- Prepare to start Routine "finish" ---
continueRoutine = True
# update component parameters for each repeat
# setup some python lists for storing info about the mouse_instr
gotValidClick = False  # until a click is received
skip_instr.keys = []
skip_instr.rt = []
_skip_instr_allKeys = []
# keep track of which components have finished
finishComponents = [finish_text, mouse_instr, skip_instr]
for thisComponent in finishComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "finish" ---
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *finish_text* updates
    if finish_text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        finish_text.frameNStart = frameN  # exact frame index
        finish_text.tStart = t  # local t and not account for scr refresh
        finish_text.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(finish_text, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'finish_text.started')
        finish_text.setAutoDraw(True)
    # *mouse_instr* updates
    if mouse_instr.status == NOT_STARTED and t >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        mouse_instr.frameNStart = frameN  # exact frame index
        mouse_instr.tStart = t  # local t and not account for scr refresh
        mouse_instr.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(mouse_instr, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.addData('mouse_instr.started', t)
        mouse_instr.status = STARTED
        mouse_instr.mouseClock.reset()
        prevButtonState = mouse_instr.getPressed()  # if button is down already this ISN'T a new click
    if mouse_instr.status == STARTED:  # only update if started and not finished!
        buttons = mouse_instr.getPressed()
        if buttons != prevButtonState:  # button state changed?
            prevButtonState = buttons
            if sum(buttons) > 0:  # state changed to a new click
                continueRoutine = False  # abort routine on response    
    # *skip_instr* updates
    waitOnFlip = False
    if skip_instr.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        skip_instr.frameNStart = frameN  # exact frame index
        skip_instr.tStart = t  # local t and not account for scr refresh
        skip_instr.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(skip_instr, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'skip_instr.started')
        skip_instr.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(skip_instr.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(skip_instr.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if skip_instr.status == STARTED and not waitOnFlip:
        theseKeys = skip_instr.getKeys(keyList=['space'], waitRelease=False)
        _skip_instr_allKeys.extend(theseKeys)
        if len(_skip_instr_allKeys):
            skip_instr.keys = _skip_instr_allKeys[-1].name  # just the last key pressed
            skip_instr.rt = _skip_instr_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in finishComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "finish" ---
for thisComponent in finishComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# store data for thisExp (ExperimentHandler)
thisExp.nextEntry()
# the Routine "finish" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()
# Run 'End Experiment' code from code_2
stream.stop_stream()
stream.close()
p.terminate()
# save mic recordings
for tag in mic.clips:
    for i, clip in enumerate(mic.clips[tag]):
        clipFilename = 'recording_mic_%s.wav' % tag
        # if there's more than 1 clip with this tag, append a counter for all beyond the first
        if i > 0:
            clipFilename += '_%s' % i
        clip.save(os.path.join(micRecFolder, clipFilename))

# --- End experiment ---
# Flip one final time so any remaining win.callOnFlip() 
# and win.timeOnFlip() tasks get executed before quitting
win.flip()

# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv', delim='auto')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
if eyetracker:
    eyetracker.setConnectionState(False)
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
